/*****************************************************************************
 * Copyright (C) 2007 Herve Lombaert <herve.lombaert@polymtl.ca>
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the
 * Free Software Foundation, Inc.,
 * 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 ****************************************************************************/


/**
 * @file	error.cpp
 * @author	Herve Lombaert
 * @date	January 17th 2006
 */


#include <error.h>


#if WIN32
#define vsnprintf _vsnprintf
#define snprintf _snprintf
#endif

/* Use a printf-like syntax */
Error::Error(const char* msg, ...)
{
	va_list arg;
	va_start(arg, msg);
	vsnprintf(this->msg, 1024, msg, arg);
	va_end(arg);
}

/* Add a line to the error description with a filename/code line */
void Error::tag(const char* msg, ...)
{
	char newline[1024];
	va_list arg;
	va_start(arg, msg);
	vsnprintf(newline, 1024, msg, arg);
	va_end(arg);
	char newmsg[1024];
	snprintf(newmsg, 1024, "%s\n%s", this->msg, newline);
	strncpy(this->msg, newmsg, 1024);
}

/* Print error message */
void Error::print() const
{
	printf("[error message]\n%s\n", msg);
}

#if WIN32
#undef vsnprintf
#undef snprintf
#endif

